<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <meta name="description" content="" />
    <meta name="author" content="" />

    <title>Login - Coin of Farmer</title>

    <!-- Custom fonts for this template-->
    <link
      href="vendor/fontawesome-free/css/all.min.css"
      rel="stylesheet"
      type="text/css"
    />

    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.24/css/jquery.dataTables.css">

    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <!-- Custom styles for this template-->
    <link href="css/sb-admin-2.min.css" rel="stylesheet" />
    <link href="css/my-coin.css" rel="stylesheet" />
  </head>

  <body class="bg-gradient-primary" ng-app="LoginExplorer">
    <div class="container">
      <!-- Outer Row -->
      <div class="row main-wrapper justify-content-center align-items-center">
        <div class="col-xl-10 col-lg-12 col-md-9">
          <div class="card o-hidden border-0 shadow-lg my-5">
            <div class="card-body p-0">
              <!-- Nested Row within Card Body -->
              <div class="row">
                <div
                  class="col-lg-6 d-none d-lg-block bg-login-image min-height"
                ></div>
                <div class="col-lg-6">
                  <div class="p-5">
                    <div class="text-center">
                      <h1 class="h4 text-gray-900 mb-4">Welcome Back!</h1>
                    </div>
                    <div ng-controller="loginController">
                      <form
                        class="user"
                        name="loginForm"
                        novalidate
                        onsubmit="return false;"
                      >
                        <div class="form-group">
                          <input
                            type="password"
                            class="form-control form-control-user"
                            placeholder="Password"
                            name="password"
                            ng-model="password"
                            value="123"
                          />
                        </div>

                
                          <label class="btn btn-primary btn-user btn-block" style="height: 45px; background-color: #FF6347;">
                            Upload your key
                            <input
                              id="file" name="file"
                              type="file"
                              style="visibility: hidden; margin-bottom: 15px;"
                            />
                        </label>
            
                          <input
                            type="submit"
                            class="btn btn-primary btn-user btn-block"
                            value="Access my wallet"
                            ng-click="login(password)"
                            ng-disabled="registerForm.privateKey.$invalid || registerForm.publicKey.$invalid ||registerForm.password.$invalid"
                          />
                      </form>
                    </div>
                    <hr />
                    <div class="text-center">
                      <a class="small" href="register.html"
                        >Create New Wallet!</a
                      >
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular.min.js"></script>

    <!-- Bootstrap core JavaScript-->
    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>

    <!-- Core plugin JavaScript-->
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Custom scripts for all pages-->
    <script src="js/sb-admin-2.min.js"></script>

    <script>
      const app = angular.module("LoginExplorer", []);
      app.controller("loginController", async function ($scope, $http) {
        function readFileAsync(file) {
            return new Promise((resolve, reject) => {
              let reader = new FileReader();

              reader.onloadend = (e) => {
                resolve(e.target.result);
              };

              reader.onerror = reject;

              reader.readAsBinaryString(file);
            })
          }

        $scope.login = async function (password) {
          const f = document.getElementById('file').files[0];
          let privateKey = "";
          let publicKey = "";

          if (f) {
            const data = JSON.parse(await readFileAsync(f));
            privateKey = data.privateKey;
            publicKey = data.publicKey;
          }

          $http({
            url: "/login",
            method: "POST",
            data: {
              privateKey: privateKey,
              publicKey: publicKey,
              password: password,
            },
          }).then(
            function (response) {
              const isAuth = response.data.isAuth;

              if (isAuth) {
                const { privateKey, publicKey } = response.data.user;
                localStorage.setItem("privateKey", privateKey);
                localStorage.setItem("publicKey", publicKey);

                window.location.href = "./index.html";
              } else {
                console.log("failed");
              }
            },
            function (response) {
              console.log("failed");
            }
          );
        };
      });
    </script>
  </body>
</html>
